import { QueryRunner } from "./QueryRunner";
import { Driver } from "../driver/Driver";
/**
 * Represents functionality to provide a new query runners, and release old ones.
 * Also can provide always same query runner.
 *
 * todo: rename to QueryExecutor ?
 */
export declare class QueryRunnerProvider {
    protected driver: Driver;
    protected useSingleQueryRunner: boolean;
    protected reusableQueryRunner: QueryRunner;
    protected reusableQueryRunnerPromise: Promise<QueryRunner>;
    /**
     * Indicates if this entity manager is released.
     * Entity manager can be released only if custom queryRunnerProvider is provided.
     * Once entity manager is released, its repositories and some other methods can't be used anymore.
     */
    protected _isReleased: boolean;
    constructor(driver: Driver, useSingleQueryRunner?: boolean);
    readonly isReleased: boolean;
    /**
     * Provides a new query runner used to run repository queries.
     * If use useSingleQueryRunner mode is enabled then reusable query runner will be provided instead.
     */
    /**
     * Releases reused query runner.
     */
    releaseReused(): Promise<void>;
}
